#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire400one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire400one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  


global shot2one4004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


                                    
# -------------------------------------------------------------------------------------------------
# 400
# -------------------------------------------------------------------------------------------------                                          
shot2one4004xi = {
                  1:'0x0y399z',
                  2:'0x12y399z',
                  3:'0x16y399z',
                  4:'0x264y299z',
                  5:'0x360y174z',
                  6:'0x4y399z',
                  7:'0x51y396z',
                  8:'0x8y399z',
                  9:'104x303y238z',
                  10:'105x349y163z',
                  11:'107x211y322z',
                  12:'107x332y195z',
                  13:'10x305y257z',
                  14:'112x264y278z',
                  15:'116x202y324z',
                  16:'119x295y241z',
                  17:'11x0y399z',
                  18:'11x372y144z',
                  19:'123x324y198z',
                  20:'123x341y167z',
                  21:'124x255y281z',
                  22:'125x193y327z',
                  23:'12x9y399z',
                  24:'133x183y329z',
                  25:'133x286y244z',
                  26:'136x246y284z',
                  27:'139x315y202z',
                  28:'13x261y302z',
                  29:'140x173y331z',
                  30:'140x333y170z',
                  31:'147x163y333z',
                  32:'147x236y287z',
                  33:'147x277y248z',
                  34:'153x153y335z',
                  35:'155x305y205z',
                  36:'156x324y174z',
                  37:'158x142y338z',
                  38:'158x225y289z',
                  39:'15x13y399z',
                  40:'160x266y251z',
                  41:'163x132y340z',
                  42:'167x121y342z',
                  43:'167x214y292z',
                  44:'169x295y209z',
                  45:'172x256y254z',
                  46:'172x313y177z',
                  47:'176x203y295z',
                  48:'184x244y257z',
                  49:'184x284y212z',
                  50:'185x191y298z',
                  51:'187x302y181z',
                  52:'18x357y177z',
                  53:'192x179y300z',
                  54:'195x232y260z',
                  55:'197x272y216z',
                  56:'199x167y303z',
                  57:'1x47y397z',
                  58:'202x291y184z',
                  59:'205x155y305z',
                  60:'205x220y263z',
                  61:'210x260y219z',
                  62:'211x142y308z',
                  63:'214x207y266z',
                  64:'216x278y188z',
                  65:'21x20y499z',
                  66:'221x247y222z',
                  67:'223x194y269z',
                  68:'229x265y192z',
                  69:'230x180y272z',
                  70:'232x233y226z',
                  71:'237x166y275z',
                  72:'23x331y222z',
                  73:'241x251y195z',
                  74:'243x219y229z',
                  75:'252x205y232z',
                  76:'252x237y199z',
                  77:'261x190y235z',
                  78:'263x222y202z',
                  79:'26x302y260z',
                  80:'273x207y205z',
                  81:'27x257y305z',
                  82:'2x3y399z',
                  83:'31x370y148z',
                  84:'36x354y181z',
                  85:'3x0y399z',
                  86:'3x43y397z',
                  87:'40x252y307z',
                  88:'40x327y225z',
                  89:'41x297y263z',
                  90:'4x6y399z',
                  91:'50x366y152z',
                  92:'52x247y310z',
                  93:'54x350y184z',
                  94:'56x292y266z',
                  95:'56x323y228z',
                  96:'5x10y399z',
                  97:'5x334y218z',
                  98:'5x39y398z',
                  99:'64x241y312z',
                  100:'69x361y156z',
                  101:'6x35y398z',
                  102:'71x286y269z',
                  103:'72x345y188z',
                  104:'73x317y232z',
                  105:'76x234y315z',
                  106:'7x0y399z',
                  107:'7x14y399z',
                  108:'7x18y399z',
                  109:'7x30y398z',
                  110:'85x279y272z',
                  111:'87x227y317z',
                  112:'87x356y159z',
                  113:'88x310y235z',
                  114:'8x22y399z',
                  115:'8x26y399z',
                  116:'90x339y192z',
                  117:'97x219y319z',
                  118:'99x272y275z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire400one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire400one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE400ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE400ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE400ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE400ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE400ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE4004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one4004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE400ONE4XI - SUCCEEDED TO PUT SHOT2ONE4004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE4004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE400ONE4XI *** FAILED TO PUT SHOT2ONE4004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE400ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one4004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one4004xi</nack2put4xi>" 
                   
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
  
        publisher_channel2one.send(message2send4one) 
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE400ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one4004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE400ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE400ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#" 
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire400one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
